#!/usr/bin/env ruby
#  print_wp_distances.rb
#
#  Print to STDOUT all the wp-to-wp distances
#
#  Copyright 2014 Howard Hughes Medical Institute.
#  All rights reserved.
#  Use is subject to Janelia Farm Research Campus Software Copyright 1.1
#  license terms ( http://license.janelia.org/license/jfrc_copyright_1_1.html )
#  
#
#

require_relative "rubylix.rb"
require_relative "FrealixFilament.rb"
require_relative "FrealixAli.rb"

require 'optparse'

options = {}
defaults = {}

optparse = OptionParser.new do |opts|
  opts.banner = "Usage: print_wp_distances.rb [options] input"

  # Help message
  opts.on_tail("-h","--help","Show this message") do
    puts opts
    exit
  end

end

optparse.parse!

@input_waypoints_filename = ARGV[0]
  

#
# Get filaments from the waypoints file
#
ali_in = FrealixAli.new(filename=@input_waypoints_filename)
fils = FrealixFilament.filamentsFromWaypoints(ali_in.getWaypoints)

# Loop over filaments
fils.each{|fil| 
	fil.wps.each_with_index{|wp,i|
		puts fil.wps[i].path_length - fil.wps[i-1].path_length if (i > 1)
	}
}
