C***********************************************************************
      SUBROUTINE CALCSINC(SINCLUT,N)
C***********************************************************************
C  Calculates table of sinc function in 1 deg steps out to N=2000 deg
C
C  Fortran 95 style, including FORALL
C                                                          ALR 31-Mar-09
C
C***********************************************************************
      IMPLICIT NONE

      INTEGER, INTENT(IN   ) ::  N
      REAL,    INTENT(INOUT) ::  SINCLUT(*)


      REAL     :: PI
      INTEGER  :: J

      PARAMETER  (PI=3.1415926535897)

      FORALL (J = 1:N)
        SINCLUT(J)=SIN(FLOAT(J)*PI/180.0)/(FLOAT(J)*PI/180.0)
      END FORALL

      RETURN
      END
