module mode_bin_par
    ! Modules
    use runtime_parameters
    use modes
    use rtps

    implicit none
    type(mode) :: bin_par

    type(rtp_char), target  ::  input_filename  =               &
        rtp_char(   value='input.par',                  &
                    keyword='INPUT_FILENAME',           &
                    description='')
  
  
    type(rtp_char), target  ::  output_filename  =               &
        rtp_char(   value='output.par',                  &
                    keyword='OUTPUT_FILENAME',           &
                    description='')
  
  
    type(rtp_intg), target  ::  bin_factor  =               &
        rtp_intg(   value=2,                  &
                    keyword='BIN_FACTOR',           &
                    description='')
  
  
    type(rtp_logi), target  ::  unbin  =               &
        rtp_logi(   value=.false.,                  &
                    keyword='UNBIN',           &
                    description='')
  
contains

subroutine mode_bin_par_init_and_run
    implicit none
    ! Intialise the mode
    call bin_par%init(command='BIN_PAR',subroutine=mode_bin_par_slave,short_description='Add description here')

    ! Add RTPs to the mode
    call bin_par%add_rtp(input_filename)
    call bin_par%add_rtp(output_filename)
    call bin_par%add_rtp(bin_factor)
    call bin_par%add_rtp(unbin)

    ! Run the mode
    call bin_par%run()


end subroutine mode_bin_par_init_and_run

subroutine mode_bin_par_slave
    use frealix_parameters
    implicit none
    ! Variables


    ! Start work
    call frealix2_par_bin(input_filename%value,output_filename%value,bin_factor%value,unbin%value)


end subroutine mode_bin_par_slave

end module mode_bin_par
