!module handlers
!  use gtk, only: gtk_container_add, gtk_drawing_area_new, gtk_events_pending, gtk&
!  &_main, gtk_main_iteration, gtk_main_iteration_do, gtk_widget_get_window, gtk_w&
!  &idget_queue_draw, gtk_widget_show, gtk_window_new, gtk_window_set_default, gtk&
!  &_window_set_default_size, gtk_window_set_title, true, false, c_null_ptr, c_null_char, &
!  & gtk_window_toplevel, gdk_colorspace_rgb, gtk_init, g_signal_connect, &
!  &CAIRO_FONT_SLANT_NORMAL, cairo_font_weight_normal
!
!  use cairo, only: cairo_arc, cairo_create, cairo_curve_to, cairo_destroy, cairo_&
!  &get_target, cairo_line_to, cairo_move_to, cairo_new_sub_path, cairo_paint, cai&
!  &ro_select_font_face, cairo_set_font_size, cairo_set_line_width, cairo_set_sour&
!  &ce, cairo_set_source_rgb, cairo_show_text, cairo_stroke, cairo_surface_write_t&
!  &o_png
!
!  use gdk, only: gdk_cairo_create, gdk_cairo_set_source_pixbuf
!
!  use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, gdk_pix&
!  &buf_get_rowstride, gdk_pixbuf_new
!
!  use iso_c_binding
!
!implicit none
!
!integer(c_int) :: run_status = true
!  integer(c_int) :: boolresult
!  logical :: boolevent
!
!  type(c_ptr) :: my_pixbuf
!  character(kind=c_char), dimension(:), pointer :: pixel
!  integer(kind=c_int) :: nch, rowstride, width, height
!  logical :: finished
!
!contains
!  ! User defined event handlers go here
!  function delete_event_test (widget, event, gdata) result(ret) bind(c)
!    use iso_c_binding, only: c_ptr, c_int
!integer(c_int) :: ret
!    type(c_ptr), value :: widget, event, gdata
!    !print *, "Delete_event"
!    run_status = false
!    ret = false
!  end function delete_event_test
!
!  subroutine pending_events_test ()
!    do while(iand(gtk_events_pending(), run_status) /= false)
!      boolresult = gtk_main_iteration_do(false) ! False for non-blocking
!    end do
!end subroutine pending_events_test
!
!  function expose_event_test (widget, event, gdata) result(ret) bind(c)
!    use iso_c_binding, only: c_int, c_ptr
!implicit none
!integer(c_int) :: ret
!    type(c_ptr), value, intent(in) :: widget, event, gdata
!    type(c_ptr) :: my_cairo_context
!    integer :: cstatus
!
!    my_cairo_context = gdk_cairo_create (gtk_widget_get_window(widget))
!
!    call cairo_set_line_width(my_cairo_context, 1d0)
!    call cairo_set_source_rgb(my_cairo_context, 0d0, 0d0, 1d0)
!    call cairo_move_to(my_cairo_context, 100d0, 50d0)
!    call cairo_line_to(my_cairo_context, 700d0, 700d0)
!    call cairo_stroke(my_cairo_context)
!
!
!    call cairo_set_source_rgb(my_cairo_context, 1d0, 0d0, 0d0)
!    call cairo_set_line_width(my_cairo_context, 3d0)
!    call cairo_move_to(my_cairo_context, 60d0, 0d0)
!    call cairo_curve_to(my_cairo_context, 600d0, 50d0, 135d0, 45d0, 500d0, 500d0)
!    call cairo_stroke(my_cairo_context)
!
!    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 700d0/4d0, 700d0/4d0)
!    call cairo_paint(my_cairo_context)
!
!    call cairo_set_source_rgb(my_cairo_context, 1d0, 1d0, 0d0)
!    call cairo_set_line_width(my_cairo_context, 2d0)
!    call cairo_move_to(my_cairo_context, 0d0, height/2d0)
!    call cairo_line_to(my_cairo_context, 1d0*width, height/2d0)
!    call cairo_move_to(my_cairo_context, width/2d0+width/12d0, 0d0)
!    call cairo_line_to(my_cairo_context, width/2d0+width/12d0, height*1d0)
!    call cairo_stroke(my_cairo_context)
!
!    call cairo_select_font_face(my_cairo_context, "Times"//c_null_char, cairo_font_slant_normal, &
!                                 & cairo_font_weight_normal)
!    call cairo_set_font_size (my_cairo_context, 16d0)
!    call cairo_move_to(my_cairo_context, 200d0, 200d0)
!    call cairo_show_text (my_cairo_context, "Mandelbrot set"//c_null_char)
!
!    call cairo_new_sub_path(my_cairo_context)
!    call cairo_arc(my_cairo_context, 300d0, 300d0, 100d0, 0d0, 3.14159d0)
!    call cairo_stroke(my_cairo_context)
!
!    if (finished) then
!cstatus = cairo_surface_write_to_png(cairo_get_target(my_cairo_context), "cairo.png"//c_null_char)
!      print *, cstatus
!    end if
!call cairo_destroy(my_cairo_context)
!    ret = false
!  end function expose_event_test
!end module handlers

module mode_test
    ! Modules
    use modes
    use rtps

    implicit none
    type(mode) :: test

    type(rtp_char), target  ::  input_file_1  =       &
        rtp_char(   value='test_in',                  &
                    keyword='INPUT_FILE_1',           &
                    description='')

contains

subroutine mode_test_init_and_run
    ! Intialise the mode
    call test%init(command='TEST',subroutine=mode_test_slave,short_description='Add description here')

    ! Add RTPs to the mode
    !call test%add_rtp(input_file_1)

    ! Run the mode
    call test%run()

end subroutine mode_test_init_and_run


subroutine mode_test_slave
    use images
    use imagefiles
    use images_arithm
    use rotation_matrices
    implicit none
    ! Variables

!    ! Create large test image
!	print *, 'generating large test image'
!    test_large%logical_dimensions = (/ 5120,5120,1 /)
!    call test_large%Allocate()
!    test_large%real_values = 1.0
!    call circ_mask(test_large,rad=2000.0)
!    !call test_large%ApplyCosineDisc(rad=2000.0,falloff=20.0,mask_with_average=.FALSE.)
!    call test_large%WriteToDisk('test_large.mrc')
!
!    ! Bin in real space
!	print *, 'real space binning'
!    call test_large%BinTo(test_binned_real,10,correct_shift=.FALSE.)
!    call test_binned_real%WriteToDisk('test_binned_real.mrc')
!
!	! Bin in real space, with shift correction
!	print *, 'real space binning, with shift correction'
!	call test_large%BinTo(test_binned_real,10,correct_shift=.TRUE.)
!	call test_binned_real%WriteToDisk('test_binned_real_shift.mrc')
!
!    ! Bin in reciprocal space
!	print *, 'reciprocal space cropping'
!    test_binned_fourier = test_large
!    call test_binned_fourier%ForwardFFT()
!    call test_binned_fourier%Crop(newdim=(/512,512,1/))
!    call test_binned_fourier%BackwardFFT()
!    call test_binned_fourier%WriteToDisk('test_binned_fourier.mrc')
!
!
!    ! Unbin
!	print *, 'unbinning'
!    test_small%logical_dimensions = (/ 512,512,1 /)
!    call test_small%Allocate()
!    test_small%real_values = 1.0
!    call circ_mask(test_small,rad=180.0)
!    call test_small%WriteToDisk('test_small.mrc')
!    call test_small%BinTo(test_unbinned,2,unbin=.TRUE.,correct_shift=.TRUE.)
!    call test_unbinned%WriteToDisk('test_small_unbinned.mrc')
!
!    ! Rotation
!    matrix1 = rotmat(180.0,0.0,0.0)
!
!    ! Rotate both binned imagesi
!	print *, 'rotation'
!    call test_binned_real%Rotate(test_rot,matrix1)
!    call test_rot%WriteToDisk('test_binned_real_180.mrc')
!    test_rot%real_values = 0.0
!    call test_binned_fourier%Rotate(test_rot,matrix1)
!    call test_rot%WriteToDisk('test_binned_fourier_180.mrc')


    ! Print out sinc stuff
    !call test_sinc_2d

	!
	!call test_bin_one_freq_at_a_time()

	!call test_amyloid_fourier_mask()

	!call spi_slice_symmetry()

	!call test_amyloid_mask()

	!call test_3d_slices()

	!call test_gtk()

	!call test_crop()

	!call test_br_estimator_stats()

	!call test_drift_weights()

	!call test_crossover_angle()

    !call test_file_io()

    !call test_new_file_io()

    !call make_ctf_image()

    !call rescale_ali()

    call spline_fit_test()

end subroutine mode_test_slave

subroutine spline_fit_test
    use Curves
    use NumericTextFiles

    !
    real,   allocatable     ::  x(:), y(:)
    type(Curve)             ::  my_curve
    type(NumericTextFile)   ::  input_file!, output_file
    integer                 ::  i

    ! Open input file
    !call input_file%Init('May08_06_30_33_tif_refined_particle_shifts.txt',open_to_read)
    call input_file%Init('actual_shift.txt',open_to_read)

    ! Allocate memory for data
    allocate(   x(input_file%records_per_line), &
                y(input_file%records_per_line) )

    x = (/ (real(i),i=1,size(x)) /)
    call input_file%ReadNextDataLine(y)

    ! Set up the curve object
    call my_curve%Init(size(x))
    call my_curve%AddPoints(x,y)

    ! Spline fit
    call my_curve%FitSplineToData(print_result_stats=.true.)
    call my_curve%FitPolynomialToData()

    ! Print results
    write(*,'(4(a12,1x))') 'x','y','fit (spline)', 'fit (poly)'
    do i=1,size(x)
        write(*,'(4(f12.4,1x))') x(i),y(i),my_curve%GetSplineY(i), my_curve%GetSplineY(i)
    enddo

end subroutine spline_fit_test

subroutine rescale_ali
    use filaments_base
    use filaments, only : filament_change_pixel_size
    use frealix_parameters
    implicit none
    type(filament), allocatable ::  fils(:)
    integer ::  current_fil, current_wp
    real, parameter :: old_pixel_size = 1.1256
    real, parameter :: new_pixel_size = 1.2156
    ! parse the input waypoints file
    call filaments_from_frealix_par_noinit(fils,'frealix_round_010/waypoints.ali.orig',old_pixel_size)
    ! loop over filaments
    do current_fil=1,size(fils)
        call fils(current_fil)%film%SetPixelSize(old_pixel_size)
        do current_wp=1,size(fils(current_fil)%wp)
            fils(current_fil)%wp(current_wp)%coo(1:2) = ((fils(current_fil)%wp(current_wp)%coo(1:2) - 1.0e0) &
                                                    * old_pixel_size / new_pixel_size) + 1.0e0
        enddo
    enddo
    ! write out the new waypoints file
    call filaments_to_frealix_par(fils,'frealix_round_010/waypoints.ali.scaled')
    print *, 'output par file = frealix_round_010/waypoints.ali.scaled'

end subroutine rescale_ali

subroutine make_ctf_image()
    use images_ctf
    use Images
    type(Image) ::  my_img
    type(ctf_parameters) :: my_ctf


    call ctf_parameters_init(my_ctf,300.0,2.0,0.07,1.6,1.6,0.0)
    call my_img%Allocate(dims=[256,256,1])
    call ctf_to_img(my_ctf,my_img,2.08,.true.)
    my_img%real_values = my_img%real_values**2
    call my_img%WriteToDisk('dbg_ctf.mrc')

end subroutine make_ctf_image

subroutine test_crossover_angle()
    use Images
    use images_helices, only : find_angle_of_crossover
    use helices
    implicit none
    type(image)             ::  my_image
    type(helical_symmetry)  ::  my_helix
    real                    ::  crossover_angle
    ! start work
    !call my_image%ReadFromDisk('frealix_round_010/3drec_008_slice_xy_000008.mrc')
    call my_image%ReadFromDisk('frealix_round_009/3drec_006_slice_xy_000055.mrc')
    my_helix%axial_symmetry = 2
    call find_angle_of_crossover(my_image,my_helix,crossover_angle)
    write(*,'(a,f0.2)') '**info(test_crossover_angle): crossover_angle = ', crossover_angle

end subroutine test_crossover_angle


!subroutine test_new_file_io()
!    use ImageFilesCore
!    implicit none
!    ! Private variables
!    type(ImageFileCore)     ::  myImageFile, myOutputImageFile
!    real,   allocatable     ::  rvalues(:,:,:)
!    integer                 ::  i,j,k
!    integer                 ::  address
!    ! Start work
!
!    call myImageFile%Init('test.mrc')
!    call myOutputImageFile%Init('test2.mrc',dim_x=2,dim_y=2,dim_z=2)
!    call myImageFile%ReadSlicesFromDisk(1,2,rvalues)
!    print *, rvalues
!    address = 0
!    do k=1,size(rvalues,3)
!        do j=1,size(rvalues,2)
!            do i=1,size(rvalues,1)-2
!                address = address + 1
!                rvalues(i,j,k) = rvalues(i,j,k) + address
!            enddo
!        enddo
!    enddo
!    print *, rvalues
!    call myOutputImageFile%WriteSlicesToDisk(1,2,rvalues)
!
!end subroutine test_new_file_io

!subroutine test_file_io()
!    use imagefiles
!    use Images, only : image
!    use images_comparison, only : images_are_equal
!    implicit none
!    !
!    type(imagefile)     ::  imgfile_f, imgfile_c
!    type(image)         ::  img_f, img_c
!    !
!    call imgfile_f%init(filename='test.mrc',intent='in',use_c_io=.false.)
!    call imgfile_c%init(filename='test.mrc',intent='in',use_c_io=.true.)
!    ! read data
!    write(*,'(a)') '**info(test_file_io): about to read image, f style'
!    call imgfile_f%read_image(img_f,print_out_read_speed=.true.)
!    write(*,'(a)') '**info(test_file_io): about to read image, c style'
!    call imgfile_c%read_image(img_c,print_out_read_speed=.true.)
!    ! check we got the same result
!    if (images_are_equal(img_f,img_c)) then
!        write(*,'(a)') '**info(test_file_io): images are the same'
!    else
!        write(*,'(a)') '**error(test_file_io): images are not the same'
!    endif
!    ! close files
!    call imgfile_f%close()
!    call imgfile_c%close()
!end subroutine test_file_io


subroutine test_drift_weights()
    use Images
    use Globals, only : pi
    implicit none
    ! Variables
    type(image) ::  img
    real        ::  drift_x,drift_y, origin(3)
    real        ::  drift,drift_rad,spa_freq,drift_weight
    real        ::  x,y,xx,yy
    integer     ::  i,j
    ! Start work
    call img%Allocate(dims=[3500,3500,1])
    img%real_values = 1.0
    drift_x = 3.0
    drift_y = 1.0

    !
    if (img%is_in_real_space .and. img%object_is_centered_in_box) then
        origin = img%physical_address_of_box_center
    else
        origin = [1,1,1]
    endif

    !
    do j=1,img%logical_dimensions(2)
        y = J-ORIGIN(2)
        yy = y/img%logical_dimensions(2)
        do i=1,img%logical_dimensions(1)
            x = I-ORIGIN(1)
            xx = x/img%logical_dimensions(1)
            !
            spa_freq = sqrt(xx**2+YY**2)
            drift = xx * drift_x + yy * drift_y
            if (spa_freq .eq. 0.0) then
                drift = 0.0
            else
                drift = drift / spa_freq
            endif
            drift_rad = drift * 2.0 * pi * spa_freq ! this is product Tv in my notes 10-Jul-2013 (Alexis)
            if (abs(drift_rad) .gt. 0.00001) then
                drift_weight = sqrt(sin(drift_rad)**2 +(1 - cos(drift_rad))**2)
                drift_weight = drift_weight / abs(drift_rad)
                img%real_values(i,j,1)=drift_weight
            endif
        enddo
    enddo

    call img%WriteToDisk('drift_weights.mrc')

end subroutine test_drift_weights


!>  \brief  Study the statistics of the unbiased snr estimator from Bershad & Rockmore
subroutine test_br_estimator_stats()
    use Images
    use ImageNoise
    use fscs, only : compute_fsc
    use runtime_parameters, only : available_lun
    implicit none
    ! Private variables
    type(image)         ::  noisy(2)
    integer, parameter  ::  num_tests = 1000
    integer, parameter  ::  dims(3) = (/128,128,128/)
    real                ::  snr = 1.0
    integer             ::  current_test, i
    real, allocatable   ::  current_fsc(:), all_fscs(:,:)
    integer             ::  csv_lun
    ! Start work

    ! Allocate memory for the images
    do i=1,2
        call noisy(i)%Allocate(dims=dims)
    enddo

    ! Loop over tests
    write(*,'(a)') '**info(test_br_estimator_stats): running tests...'
    do current_test=1,num_tests
        write(*,'(a,i0,a,i0)') '**info(test_br_estimator_stats): on test ', current_test, ' of ', num_tests
        ! Generate images
        noisy(1:2)%is_in_real_space   = .true.
        noisy(1)%real_values = 0.0
        call AddGaussianNoise(noisy(1),sqrt(snr),seed=(CURRENT_TEST-1)*3)
        noisy(2)%real_values = noisy(1)%real_values
        call AddGaussianNoise(noisy(1),1.0,seed=(CURRENT_TEST-1)*3+1)
        call AddGaussianNoise(noisy(2),1.0,seed=(CURRENT_TEST-1)*3+2)
        ! Compute fsc
        call noisy(1)%ForwardFFT()
        call noisy(2)%ForwardFFT()
        call compute_fsc(noisy(1),noisy(2),current_fsc)
        ! Allocate memory for the FSCs
        if (.not. allocated(all_fscs)) allocate(all_fscs(size(current_fsc),num_tests))
        ! Store current fsc
        all_fscs(:,current_test) = current_fsc(:)
    enddo

    ! Print out the FSCs to a file
    write(*,'(a)') '**info(test_br_estimator_stats): writing out csv file'
    csv_lun = available_lun()
    open(unit=csv_lun,file='all_fscs.csv',action='WRITE')
    ! Each line of the file will correspond to a spatial frequency
    do i=1,size(current_fsc)
        do current_test=1,NUM_TESTS-1
            write(csv_lun,'(F0.6,a)',advance='NO') all_fscs(i,current_test), ','
        enddo
        write(csv_lun,'(F0.6)') all_fscs(i,num_tests)
    enddo
    close(csv_lun)

    write(*,'(a)') '**info(test_br_estimator_stats): all done'
end subroutine test_br_estimator_stats


subroutine test_crop()
    use images
    use imagefiles
    implicit none
    !
    type(image)     ::  img
    !
    call img%ReadFromDisk('test.img')
    call img%Resize((/512,512,1/))
    call img%WriteToDisk('test2.img')
end subroutine test_crop

!subroutine test_gtk()
!    use gtk, only : gtk_init
!    use Images, only : image
!    use iso_c_binding
!    use handlers
!    use imagefiles
!#ifdef __intel_compiler
!    use ifport, only : sleep
!#endif
!#ifdef nagfor_compiler
!    use f90_unix_proc, only : sleep
!#endif
!    implicit none
!    ! Private variables
!    type(image) ::  img
!    type(c_ptr) ::  my_window, my_drawing_area
!    integer     ::  i,j
!    integer     ::  val, addr
!    ! Start work
!
!    finished = .FALSE.
!    call gtk_init()
!
!
!    ! Set up the main window
!    width = 600
!    height = 600
!    my_window = gtk_window_new(gtk_window_toplevel)
!    call gtk_window_set_default_size(my_window,width,height)
!    call gtk_window_set_title(my_window,"Testing gtk for Frealix"//c_null_char)
!    call g_signal_connect(my_window,"delete-event"//c_null_char, c_funloc(delete_event_test))
!
!    my_drawing_area = gtk_drawing_area_new()
!    call g_signal_connect(my_drawing_area,"expose-event"//c_null_char,c_funloc(expose_event_test))
!    call gtk_container_add(my_window,my_drawing_area)
!    call gtk_widget_show(my_drawing_area)
!
!    call gtk_widget_show(my_window)
!
!
!    !
!    my_pixbuf = gdk_pixbuf_new(gdk_colorspace_rgb, true, 8_c_int, &
!                               & width,height)
!
!    nch = gdk_pixbuf_get_n_channels(my_pixbuf)
!    rowstride = gdk_pixbuf_get_rowstride(my_pixbuf)
!    call c_f_pointer(gdk_pixbuf_get_pixels(my_pixbuf),pixel, (/width*height*nch/))
!
!    ! Initialise
!    do i=1,(width*height)*nch,nch
!        pixel(i)   = char(0)    ! r
!        pixel(I+1) = char(0)    ! g
!        pixel(I+2) = char(0)    ! b
!        pixel(I+3) = char(255)  ! a
!    enddo
!
!    ! Write image values
!    call img%ReadFromDisk('test.img')
!    do j=1,height
!        do i=1,width
!            addr = 1+NCH*((I-1)+(J-1)*width)
!
!            val  = int(img%real_values(i,j,1)/20.0*255.0)
!            pixel(ADDR+0) = char(val)
!            pixel(ADDR+1) = char(val)
!            pixel(ADDR+2) = char(val)
!            pixel(ADDR+3) = char(255)
!
!        enddo
!    enddo
!
!
!    !
!    do
!        call pending_events_test()
!        if (run_status == false) exit
!        call sleep(1)
!    end do
!
!    print *, 'EXITING TEST_GTK'
!
!end subroutine test_gtk

subroutine test_3d_slices()
    implicit none


end subroutine test_3d_slices

subroutine test_amyloid_mask()
    use masks, only : fourier_mask_init_amyloid
    use Images
    use imagefiles
    implicit none
    !
    type(image) :: m, mould
    !
    mould%logical_dimensions = [128,128,1]
    call fourier_mask_init_amyloid(m,mould,1.163,180.0,6.0)
    call m%WriteToDisk('dbg_m.mrc')
end subroutine test_amyloid_mask


subroutine spi_slice_symmetry()
    use runtime_parameters, only : filename_len
    use parsers, only : get_reals_from_column, get_ints_from_column
    use Images
    use rotation_matrices, only : euler_to_rotmat, rotation_matrix
    use images_threed, only : insert_slice_put
    use interpolation, only : default_interpol_scheme
    use ImageFiles
    implicit none
    ! Private variables
    character(len=filename_len),    parameter   ::  spi_params_fn           = 'goodparams-cc0200-side001_pol220_178.dat'
    character(len=filename_len),    parameter   ::  spi_angles_fn           = 'angles-side001_178.dat'
    character(len=filename_len),    parameter   ::  stack_fn                = 'test_image.mrc'  !'051215_tmv-flo1x-cut-pol220.mrc'
    character(len=filename_len),    parameter   ::  output_rec_fn           = '3drec.mrc'
    integer,                        parameter   ::  num_subunits_per_image  = 3
    integer,                        parameter   ::  rec_dim                 = 200
    ! Private variables
    type(imagefile)             ::  stack
    real,   allocatable         ::  spi_in_plane(:), spi_x(:), spi_y(:), spi_out_of_plane(:), spi_twist(:)
    integer,    allocatable     ::  loc_in_stack(:)
    integer                     ::  current_image
    type(image)                 ::  img, rec
    real(kind=8)                ::  PHI,theta,psi,x,y
    type(rotation_matrix)       ::  rmat
    ! Start work
    write(*,'(a)') '**info(spi_slice_symmetry): entering'

    ! Load spider alignment parameters
    call get_reals_from_column(spi_params_fn,5,spi_in_plane)
    call get_reals_from_column(spi_params_fn,6,spi_x)
    call get_reals_from_column(spi_params_fn,7,spi_y)
    call get_reals_from_column(spi_angles_fn,4,spi_out_of_plane)
    call get_reals_from_column(spi_angles_fn,5,spi_twist)
    call get_ints_from_column(spi_params_fn,8,loc_in_stack)

    ! How many images are we dealing with?
    write(*,'(a,i0)') '**info(spi_slice_symmetry): images in parameter file : ', size(spi_x)

    ! Open the stack file
    call stack%init(stack_fn)
    call stack%PrintInfo()

    ! Initialise the 3d reconstruction volume
    rec%logical_dimensions = [REC_DIM,rec_dim,REC_DIM]
    call rec%Allocate()
    rec%is_in_real_space = .false.

    ! Loop over images
    do current_image=1,1


        ! Grab the Euler angles & shifts for insertion
        phi   = spi_twist(current_image)
        theta = spi_out_of_plane(current_image)
        psi   = spi_in_plane(current_image)
        x     = spi_x(current_image)
        y     = spi_y(current_image)

        ! Write out info
        write(*,'(a,i0,a,i0,a,i0,1x,5(F0.3,1x))')   '**info(spi_slice_symmetry): on image ', current_image, ' of ', &
                                                    size(spi_x), '. Loc, x, y, in-, out-, twist = ', &
                                                    loc_in_stack(current_image), x, y, &
                                                    psi, theta, phi

        ! Convert
        call spi_to_fre(x,y,phi,theta,psi)

        ! Write out info
        write(*,'(a,i0,a,i0,a,i0,1x,5(F0.3,1x))')   '**info(spi_slice_symmetry): on image ', current_image, ' of ', &
                                                    size(spi_x), '. Loc, x, y, in-, out-, twist = ', &
                                                    loc_in_stack(current_image), x, y, &
                                                    psi, theta, phi

        ! Read image from the file
        call img%ReadFromDisk(stack,wanted_location=loc_in_stack(current_image))

        ! Resize the image
        call img%Resize([REC_DIM,rec_dim,1])

        ! Add to the 3d reconstruction

        call img%ForwardFFT()
        call img%SwapRealSpaceQuadrants()
        call img%PhaseShift(real(x),real(y),0.0)
        rmat%rmatrix = euler_to_rotmat(phi,theta,psi,reverse=.true.)
        call insert_slice_put(  rec, img, rmat, default_interpol_scheme() )

    enddo   ! End of loop over images


    ! "Finalise" the 3d reconstruction
    call rec%SwapRealSpaceQuadrants()
    call rec%BackwardFFT()

    ! Write the reconstruction to disk
    call rec%WriteToDisk(output_rec_fn)

    ! Close the stack file
    call stack%close()
end subroutine spi_slice_symmetry

subroutine spi_to_fre(x,y,phi,theta,psi)
    use rotation_matrices, only : radians
    implicit none
    real(kind=8),   intent(inout)   ::  x,y,phi,theta,psi
    ! Private variables
    real(kind=8) :: PSIR
    real(kind=8) :: X_IN, y_in
    !
    x_in = x
    y_in = y
    !
    psir = radians(-PSI)
    x = sin(psir)*y_in + cos(psir)*x_in
    y = cos(psir)*y_in - sin(psir)*x_in
    !
    psi = -PSI + 270.
    !

end subroutine spi_to_fre

subroutine test_amyloid_fourier_mask()
    use masks
    use Images
    implicit none
    !
    type(image) ::  fmask
    type(image) ::  mould

    mould%logical_dimensions = [300,300,1]
    call fourier_mask_init_amyloid(fmask,mould,pixel_size=1.2,fil_max_rad=180.0,max_spacing_align=7.0)
end subroutine test_amyloid_fourier_mask


!subroutine test_bin_one_freq_at_a_time()
!	use images
!	use interpolation, only : sinc
!	implicit none
!	!
!	type(image)	::	img,imgout,img_ampl
!	real :: freq
!	real :: sml
!	integer, parameter	::	test_addr(3) = (/18,1,1/)
!	integer, parameter	::  img_dim(3) = (/128,128,1/)
!
!	sml = epsilon(1.0)
!
!	! Create single-frequency image
!	img%logical_dimensions = img_dim
!	call img%Allocate()
!	img%complex_values = (0.0,0.0)
!	call img%ForwardFFT()
!	img%complex_values(test_addr(1),test_addr(2),test_addr(3)) = (1.0,0.0)
!	call img%BackwardFFT()
!	call img%ForwardFFT()
!	call img%BackwardFFT()
!	call img%WriteToDisk('single_freq.mrc')
!    call img%ForwardFFT()
!	call img%ComputeAmplitudeSpectrum(img_ampl)
!	call img_ampl%WriteToDisk('single_freq_ampl.mrc')
!
!
!	! Bin & write out
!	if (img%IsInFourierSpace()) call img%BackwardFFT()
!	call img%BinTo(imgout,2,preserve_center=.false.)
!	call imgout%WriteToDisk('single_freq_bin2.mrc')
!	call imgout%ForwardFFT()
!	call imgout%ComputeAmplitudeSpectrum(img_ampl)
!	call img_ampl%WriteToDisk('single_freq_bin2_ampl.mrc')
!
!	freq = (real(test_addr(1))-1.)/real(imgout%logical_dimensions(1))
!	write(*,'(a,5(F0.2,1x))') 'value, ampl of peak in Fourier space; sinc, sinc**2 = ', &
!	                                    imgout%complex_values(test_addr(1),test_addr(2),test_addr(3)), &
!										cabs(imgout%complex_values(test_addr(1),test_addr(2),test_addr(3))), sinc(freq), sinc(freq)**2
!
!	! Check: how many pixels in the ft are non-zero?
!	if (imgout%IsInRealSpace()) call imgout%ForwardFFT()
!	if (img%IsInRealSpace()) call img%ForwardFFT()
!   	write(*,'(i0,a)') count(abs(real(img%complex_values)) .gt. sml .or. abs(aimag(img%complex_values)) .gt. sml), &
!   	                    ' pixels in input image ft are non-zero'
!	write(*,'(i0,a)') count(abs(real(imgout%complex_values)) .gt. sml .or. abs(aimag(imgout%complex_values)) .gt. sml), &
!	                    ' pixels in output image ft are non-zero'
!
!
!
!end subroutine

subroutine test_sinc_2d()
    use rotation_matrices, only : radians
    use interpolation, only : sinc
    use images
    implicit none
    integer ::  i,j
    real    ::  r
    real    ::  phi
    real    ::  x,y
    real    ::  sinc_product, sinc_x, sinc_y,sinc_r
    real(kind=8)    ::  RESULT
    type(image) ::  img_sinc_product,img_sinc_radius
    real(kind=8), allocatable   ::  sinc_prod_avrot(:), sinc_rad_avrot(:)



    write(*,'(4(A,1x))') 'Radius', 'sinc(x)*sinc(y)', 'sinc(r)', 'sinc^2(r)'
    ! Loop over radius
    do i=0,100
        r = real(i)*.5/100.0
        result = 0.0D0
        ! Loop over angles
        do j=0,1000
            phi = real(j)*90./1000.
            ! Convert polar to cartesian coordinates
            x = cos(radians(phi))*r
            y = sin(radians(phi))*r
            ! Compute the value of the kernel
            sinc_x = sinc(x)
            sinc_y = sinc(y)
            sinc_product = sinc_x * sinc_y
            result = result + sinc_product
        enddo ! End loop over angles
        sinc_r = sinc(r)
        write(*,'(4(F0.5,1x))') r, result/1001.0, sinc_r, sinc_r**2
    enddo

    ! Generate an image
    img_sinc_product%logical_dimensions = (/512,512,1/)
    call img_sinc_product%Allocate()
    call img_sinc_radius%Allocate()
    do j=1,img_sinc_product%logical_dimensions(2)
        y = real(J-257)
        do i=1,img_sinc_product%logical_dimensions(1)
            x = real(I-257)
            r = sqrt(x**2+Y**2)
            img_sinc_product%real_values(i,j,1) = sinc(x/512.)*sinc(y/512.)
            img_sinc_radius%real_values(i,j,1) = sinc(r/512.)
        enddo
    enddo
    call img_sinc_product%WriteToDisk('test_sinc_prodxy.mrc')
    call img_sinc_radius%WriteToDisk('test_sinc_radius.mrc')
    call img_sinc_product%Compute1DRotationalAverage(sinc_prod_avrot)
    call img_sinc_radius%Compute1DRotationalAverage(sinc_rad_avrot)

    write(*,'(3(A,1x))') 'Radius', 'sinc(x)*sinc(y)', 'sinc^2(r)'
    do i=1,size(sinc_prod_avrot)
        write(*,'(3(F0.4,1x))') real(I-1)/512.,sinc_prod_avrot(i),sinc_rad_avrot(i)
    enddo


end subroutine test_sinc_2d

end module mode_test
