!>  \brief  Run unit tests
module mode_unit_tests
    use modes
    use rtps
    implicit none
    ! Declare mode object
    type(mode)  ::  unit_tests
    ! Declare RTPs
!    type(rtp_char)  ::  output_filename =               &
!        rtp_char(   value='output.mrc',                 &
!                    keyword='OUTPUT_FILENAME',          &
!                    description='Name of output file')
contains

subroutine mode_unit_tests_init_and_run
    ! Initialise the mode
    call unit_tests%init(  command='UNIT_TESTS',              &
                    subroutine=mode_unit_tests_slave,  &
                    short_description='Run Frealix unit tests')
    ! Add RTPs to the mode
!    call bin%add_rtp(output_filename)

    ! Run the mode
    call unit_tests%run()
end subroutine mode_unit_tests_init_and_run

subroutine mode_unit_tests_slave
    ! Modules
    use ctfs, only : ctf_unit_tests
    use threeds, only : threed_unit_tests
    use fscs, only : fsc_unit_tests
    use differential_geometry, only : space_curve_unit_tests
    use fmcs, only : fmc_unit_tests
    use coos, only : coos_unit_tests
    use images_ctf, only : image_ctf_unit_tests
    use helices, only : helix_unit_tests
    use images_helices, only : images_helices_unit_tests
    use differential_geometry, only : differential_geometry_unit_tests
    use Images, only : image_base_unit_tests, image_fft_unit_tests
    use GaussLegendreQuadratures, only : GaussLegendreQuadrature_UnitTests
    implicit none

    ! Variables

    ! Start work
    call image_base_unit_tests()
    call image_fft_unit_tests()
    call ctf_unit_tests()
    call image_ctf_unit_tests()
    call helix_unit_tests()
    call images_helices_unit_tests()
    call differential_geometry_unit_tests()
    call GaussLegendreQuadrature_UnitTests()
    call coos_unit_tests()
    call space_curve_unit_tests()
    call threed_unit_tests()
    call fmc_unit_tests()
    call fsc_unit_tests()


    !call fmc_unit_tests()


end subroutine mode_unit_tests_slave

end module mode_unit_tests
